package com.jeeplus.modules.sg.financial.erpcredit.util;

import com.jeeplus.modules.sg.financial.erpcredit.entity.*;
import com.jeeplus.modules.sg.financial.settlement.entity.MaintainData;
import org.apache.poi.hssf.usermodel.HSSFFont;
import org.apache.poi.hssf.util.HSSFColor;
import org.apache.poi.ss.usermodel.*;
import org.apache.poi.xssf.usermodel.XSSFCell;
import org.apache.poi.xssf.usermodel.XSSFFont;
import org.apache.poi.xssf.usermodel.XSSFRow;
import org.apache.poi.xssf.usermodel.XSSFWorkbook;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ExportUtil2 {

    //一览表
    public static void getSheet2(Sheet sheet,List<ErpCredit> erpCredits,List<MaintainData> maintainDataList){
        if (sheet!=null){
            Schedule schedule = null;
            XSSFRow row = (XSSFRow) sheet.getRow(0);
            XSSFCell cell = row.getCell(3);
            List<Schedule> scheduleList = ExportUtil1.getScheduleList(erpCredits, maintainDataList);
            for (int i = 0; i <10; i++) {
                schedule = scheduleList.get(i);
                row=(XSSFRow)sheet.getRow(i+6);
                cell=row.getCell(0);
                cell.setCellValue(i+1);
                cell=row.getCell(1);
                cell.setCellValue(schedule.getItemId());
                cell=row.getCell(2);
                cell.setCellValue(schedule.getItemName());
                cell=row.getCell(3);
                cell.setCellValue(schedule.getBudgetBuildProject());
                cell=row.getCell(4);
                cell.setCellValue(schedule.getBudgetInstallProject());
                cell=row.getCell(5);
                cell.setCellValue(schedule.getBudgetEquipmentValue());
                cell=row.getCell(6);
                cell.setCellValue(schedule.getBudgetOtherFee());
                cell=row.getCell(7);
                cell.setCellValue(schedule.getBudgetTotalFee());
                cell=row.getCell(8);
                cell.setCellValue(schedule.getActualBuildProject());
                cell=row.getCell(9);
                cell.setCellValue(schedule.getActualIntallProject());
                cell=row.getCell(10);
                cell.setCellValue(schedule.getActualEquipmentValue());
                cell=row.getCell(11);
                cell.setCellValue(schedule.getActualOtherFee());
                cell=row.getCell(12);
                cell.setCellValue(schedule.getActualTotalFee());
                cell=row.getCell(13);
                cell.setCellValue(schedule.getAddSubtractionLines());
                cell=row.getCell(14);
                cell.setCellValue(schedule.getAddSubtractionRate());
            }
        }

    }
    //读取得到其他费用表
   public static void getSheet3(Sheet sheet,List<ErpCredit> erpCredits,List<MaintainData> maintainDataList){
       if (null!=sheet){
           XSSFRow row = (XSSFRow) sheet.getRow(0);
           XSSFCell cell = row.getCell(3);
           ScheduleOther scheduleOther = ExportUtil1.getScheduleOfOtherExpenses(erpCredits,maintainDataList);
           List list = new ArrayList();
           list.add(scheduleOther.getRequisitionSite());
           list.add(scheduleOther.getCompensationAcquisition());
           list.add(scheduleOther.getCleaningFees());
           list.add(scheduleOther.getStorageFee());
           list.add(scheduleOther.getCompensateFee());
           list.add(scheduleOther.getManagementFee());
           list.add(scheduleOther.getPreparationFee());
           list.add(scheduleOther.getItemManageFee());
           list.add(scheduleOther.getTheTenderFee());
           list.add(scheduleOther.getSupervisionFee());
           list.add(scheduleOther.getTechnicalFee());
           list.add(scheduleOther.getSurveyFee());
           list.add(scheduleOther.getDesignFee());
           list.add(scheduleOther.getDrawingBudgetFee());
           list.add(scheduleOther.getEvaluationFee());
           list.add(scheduleOther.getEconomicFee());
           list.add(scheduleOther.getInspectionFee());
           list.add(scheduleOther.getPreparationFee());
           list.add(scheduleOther.getBasicFee());
           list.add(scheduleOther.getReserveFee());
           list.add(scheduleOther.getTotalFee());
           for (int i = 0; i < list.size(); i++) {
               row = (XSSFRow) sheet.getRow((int)i+6);
               cell=row.getCell(3);
               cell.setCellValue((String)list.get(i));
           }
       }
   }
   //移交资产—配电网资产一览表(线路)
   public static void getSheet5(Sheet sheet, List<ErpCredit> erpCredits, XSSFWorkbook workbook){
       if (null!=sheet){
           CellStyle style=getCellStyle(workbook);
           XSSFRow row = (XSSFRow) sheet.getRow(0);
           XSSFCell cell = row.getCell(0);
           TransferOfPower1 transferOfPower1 = null;
           List<TransferOfPower1> transferOfPower1s = ExportUtil1.getTransFerPower1(erpCredits);
           for (int i = 0; i < 5; i++) {
               transferOfPower1=transferOfPower1s.get(i);
               row = (XSSFRow) sheet.getRow((int)i+5);
               cell=row.getCell(0);
               cell.setCellValue(transferOfPower1.getPowerId());
               if (i == transferOfPower1s.size() - 1){ cell.setCellStyle(style); }
               cell=row.getCell(1);
               cell.setCellValue(transferOfPower1.getPowerName());
               if (i == transferOfPower1s.size() - 1){
                   cell.setCellStyle(style);
               }
               cell=row.getCell(2);
               cell.setCellValue(transferOfPower1.getPowerArea());
               if (i == transferOfPower1s.size() - 1){
                   cell.setCellStyle(style);
               }
               cell=row.getCell(3);
               cell.setCellValue(transferOfPower1.getPowerDepartment());
               if (i == transferOfPower1s.size() - 1){
                   cell.setCellStyle(style);
               }
               cell=row.getCell(4);
               cell.setCellValue(transferOfPower1.getPowerTenKvLineLength());
               if (i == transferOfPower1s.size() - 1){
                   cell.setCellStyle(style);
               }
               cell=row.getCell(5);
               cell.setCellValue(transferOfPower1.getPowerTenKvCableType());
               if (i == transferOfPower1s.size() - 1){
                   cell.setCellStyle(style);
               }
               cell=row.getCell(6);
               cell.setCellValue(transferOfPower1.getPowerBuildFee());
               if (i == transferOfPower1s.size() - 1){
                   cell.setCellStyle(style);
               }
               cell=row.getCell(7);
               cell.setCellValue(transferOfPower1.getPowerInstallFee());
               if (i == transferOfPower1s.size() - 1){
                   cell.setCellStyle(style);
               }
               cell=row.getCell(8);
               cell.setCellValue(transferOfPower1.getPowerStandInFee());
               if (i == transferOfPower1s.size() - 1){
                   cell.setCellStyle(style);
               }
               cell=row.getCell(9);
               cell.setCellValue(transferOfPower1.getPowerDeliveredAssets());
               if (i == transferOfPower1s.size() - 1){
                   cell.setCellStyle(style);
               }
               cell=row.getCell(10);
               cell.setCellValue(transferOfPower1.getPoweRequipmentFee());
           }
       }
   }
   //移交资产—配电网资产一览表（设备）
   public static void getSheet6(Sheet sheet,List<ErpCredit> erpCredits,Workbook workbook){
      if (sheet!=null){
          CellStyle style=getCellStyle(workbook);
          XSSFRow row = (XSSFRow) sheet.getRow(0);
          XSSFCell cell = row.getCell(0);
          TransferOfPower2 transferOfPower2 = null;
          List<TransferOfPower2> transferOfPower2s = ExportUtil1.getTransferOfPower2(erpCredits);
          for (int i = 0; i < 6; i++) {
              transferOfPower2=transferOfPower2s.get(i);
              row = (XSSFRow) sheet.getRow((int)i+5);
              cell=row.getCell(0);
              cell.setCellValue(transferOfPower2.getPowerId());//项目定义编号
              if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
              cell=row.getCell(1);
              cell.setCellValue(transferOfPower2.getPowerName());//配电网资产名称
              if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
              cell=row.getCell(2);
              cell.setCellValue(transferOfPower2.getPowerArea());////线路起止地点或配变所在滴
              if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
              cell=row.getCell(3);
              cell.setCellValue(transferOfPower2.getPowerDepartment());//保管部门
              if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
              cell=row.getCell(4);
              cell.setCellValue(transferOfPower2.getPowerNumber());//配变数量
              if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
              cell=row.getCell(5);
              cell.setCellValue(transferOfPower2.getPowerUnit());//计量单位
              if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
              cell=row.getCell(6);
              cell.setCellValue(transferOfPower2.getPowerCapacity());//配变容量
              if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
              cell=row.getCell(7);
              cell.setCellValue(transferOfPower2.getPowerValue());//设备价值
              if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
              cell=row.getCell(8);
              cell.setCellValue(transferOfPower2.getPowerStandInFee());//摊入费用
              if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
              cell=row.getCell(9);
              cell.setCellValue(transferOfPower2.getPowerDeliveredAssets());//交付使用资产价值
              if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
              cell=row.getCell(10);
              cell.setCellValue(transferOfPower2.getPoweRequipmentFee());//其中：附属设备价值
              if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
          }
      }
   }
   //设备材料清册
    public static void getSheet7(Sheet sheet,List<ErpCredit> erpCredits){
        XSSFRow row = (XSSFRow) sheet.getRow(0);
        XSSFCell cell = row.getCell(0);
        MaterialEquipment materialEquipment = null;
        if (null!=sheet){
            List<MaterialEquipment> materialEquipments = ExportUtil1.getMaterialEquipment(erpCredits);
            for (int i = 0; i < materialEquipments.size(); i++) {
                materialEquipment = materialEquipments.get(i);
                row = (XSSFRow) sheet.getRow((int)i+5);
                cell=row.getCell(0);
                cell.setCellValue(materialEquipment.getId());//项目定义编号
                cell=row.getCell(1);
                cell.setCellValue(materialEquipment.getMeName());
                cell=row.getCell(2);
                cell.setCellValue(materialEquipment.getMeSpecifications());
                cell=row.getCell(3);
                cell.setCellValue(materialEquipment.getMeSupplierName());//供应单位制造
                cell=row.getCell(4);
                cell.setCellValue(materialEquipment.getMeUnit());////计量单位
                cell=row.getCell(5);
                cell.setCellValue(materialEquipment.getMeNumber());////数量
                cell=row.getCell(6);
                cell.setCellValue(materialEquipment.getMeUnitPrice());////单价
                cell=row.getCell(7);
                cell.setCellValue(materialEquipment.getMeAllPrice());////合计
            }
        }
    }

    //移交资产—配电网资产一览表(线路)1
    public static void getSheet10(Sheet sheet,List<ErpCredit> erpCredits,Workbook workbook){
        if (null!=sheet){
            CellStyle style=getCellStyle(workbook);
            XSSFRow row = (XSSFRow) sheet.getRow(0);
            XSSFCell cell = row.getCell(0);
            TransferOfPower1 transferOfPower1 = null;
            List<TransferOfPower1> transferOfPower1s = ExportUtil1.getTransFerPower1(erpCredits);
            for (int i = 0; i < 6; i++) {
                transferOfPower1=transferOfPower1s.get(i);
                row = (XSSFRow) sheet.getRow((int)i+5);
                cell=row.getCell(0);
                cell.setCellValue(transferOfPower1.getPowerId());
                cell=row.getCell(1);
                cell.setCellValue(transferOfPower1.getPowerName());
                if (i == transferOfPower1s.size() - 1){ cell.setCellStyle(style); }
                cell=row.getCell(2);
                cell.setCellValue(transferOfPower1.getPowerNumberBars());
                if (i == transferOfPower1s.size() - 1){ cell.setCellStyle(style); }
                cell=row.getCell(3);
                cell.setCellValue(transferOfPower1.getPowerAssetClass());
                if (i == transferOfPower1s.size() - 1){ cell.setCellStyle(style); }
                cell=row.getCell(4);
                cell.setCellValue(transferOfPower1.getPowerArea());
                if (i == transferOfPower1s.size() - 1){ cell.setCellStyle(style); }
                cell=row.getCell(5);
                cell.setCellValue(transferOfPower1.getPowerDepartment());
                if (i == transferOfPower1s.size() - 1){ cell.setCellStyle(style); }
                cell=row.getCell(6);
                cell.setCellValue(transferOfPower1.getPowerTenKvLineLength());
                if (i == transferOfPower1s.size() - 1){ cell.setCellStyle(style); }
                cell=row.getCell(7);
                cell.setCellValue(transferOfPower1.getPowerTenKvCableType());
                if (i == transferOfPower1s.size() - 1){ cell.setCellStyle(style); }
                cell=row.getCell(8);
                cell.setCellValue(transferOfPower1.getPowerBuildFee());
                if (i == transferOfPower1s.size() - 1){ cell.setCellStyle(style); }
                cell=row.getCell(9);
                cell.setCellValue(transferOfPower1.getPowerInstallFee());
                if (i == transferOfPower1s.size() - 1){ cell.setCellStyle(style); }
                cell=row.getCell(10);
                cell.setCellValue(transferOfPower1.getPowerStandInFee());
                if (i == transferOfPower1s.size() - 1){ cell.setCellStyle(style); }
                cell=row.getCell(11);
                cell.setCellValue(transferOfPower1.getPowerDeliveredAssets());
                if (i == transferOfPower1s.size() - 1){ cell.setCellStyle(style); }
                cell=row.getCell(12);
                cell.setCellValue(transferOfPower1.getPoweRequipmentFee());
                if (i == transferOfPower1s.size() - 1){ cell.setCellStyle(style); }
            }
        }
    }
    //移交资产—配电网资产一览表（设备）2
    public static void getSheet11(Sheet sheet,List<ErpCredit> erpCredits,Workbook workbook){
        if (sheet!=null){
            CellStyle style=getCellStyle(workbook);
            XSSFRow row = (XSSFRow) sheet.getRow(0);
            XSSFCell cell = row.getCell(0);
            TransferOfPower2 transferOfPower2 = null;
            List<TransferOfPower2> transferOfPower2s = ExportUtil1.getTransferOfPower2(erpCredits);
            for (int i = 0; i <10; i++) {
                transferOfPower2=transferOfPower2s.get(i);
                row = (XSSFRow) sheet.getRow((int)i+5);
                cell=row.getCell(0);
                cell.setCellValue(transferOfPower2.getPowerId());//项目定义编号
                cell=row.getCell(1);
                cell.setCellValue(transferOfPower2.getPowerName());//配电网资产名称
                if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
                cell=row.getCell(2);
                cell.setCellValue(transferOfPower2.getPowerAssetClass());
                if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
                cell=row.getCell(3);
                cell.setCellValue(transferOfPower2.getPowerArea());////线路起止地点或配变所在滴
                if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
                cell=row.getCell(4);
                cell.setCellValue(transferOfPower2.getPowerDepartment());//保管部门
                if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
                cell=row.getCell(5);
                cell.setCellValue(transferOfPower2.getPowerNumber());//配变数量
                if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
                cell=row.getCell(6);
                cell.setCellValue(transferOfPower2.getPowerUnit());//计量单位
                if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
                cell=row.getCell(7);
                cell.setCellValue(transferOfPower2.getPowerCapacity());//配变容量
                if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
                cell=row.getCell(8);
                cell.setCellValue(transferOfPower2.getPowerValue());//设备价值
                if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
                cell=row.getCell(9);
                cell.setCellValue(transferOfPower2.getPowerStandInFee());//摊入费用
                if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
                cell=row.getCell(10);
                cell.setCellValue(transferOfPower2.getPowerDeliveredAssets());//交付使用资产价值
                if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
                cell=row.getCell(11);
                cell.setCellValue(transferOfPower2.getPoweRequipmentFee());//其中：附属设备价值
                if (i == transferOfPower2s.size() - 1){ cell.setCellStyle(style);}
            }
        }
    }

    //概述表
    public static void getSheet1(Sheet sheet, List<ErpCredit> erpCredits, List<MaintainData> maintainDataList){
       if (sheet!=null){
           GeneralSituation generalSituation = ExportUtil1.getFeneraSituation(erpCredits,maintainDataList);
           XSSFRow row = (XSSFRow) sheet.getRow(6);
           XSSFCell cell = row.getCell(6);
           cell.setCellValue(generalSituation.getOrganDataNumber());//日期，批文号

           row = (XSSFRow)sheet.getRow(9);
           cell = row.getCell(2);
           cell.setCellValue(generalSituation.getLineLength());
           cell = row.getCell(7);
           cell.setCellValue(generalSituation.getCommencementDate());

           row = (XSSFRow)sheet.getRow(10);
           cell = row.getCell(2);
           cell.setCellValue(generalSituation.getTenKvLength());
           cell = row.getCell(7);
           cell.setCellValue(generalSituation.getCompletionDate());

           row = (XSSFRow)sheet.getRow(11);
           cell=row.getCell(2);
           cell.setCellValue(generalSituation.getFourKvLength());

           row = (XSSFRow)sheet.getRow(12);
           cell=row.getCell(7);
           cell.setCellValue(generalSituation.getInvestmentBudget());

           row = (XSSFRow)sheet.getRow(13);
           cell=row.getCell(7);
           cell.setCellValue(generalSituation.getActualInvestment());//实际投资

           row = (XSSFRow)sheet.getRow(14);
           cell=row.getCell(7);
           cell.setCellValue(generalSituation.getTransferAssets());

           row = (XSSFRow)sheet.getRow(16);
           cell=row.getCell(7);
           cell.setCellValue(generalSituation.getHasItsOwn());
       }
    }
    //资产总表
    public static void getSheet4(Sheet sheet,List<ErpCredit> erpCredits){
       if (sheet!=null){
           XSSFRow row = (XSSFRow) sheet.getRow(0);
           XSSFCell cell = row.getCell(0);
           TheAssetsTotal theAssetsTotal = null;
           List<TheAssetsTotal> theAssetsTotals = ExportUtil1.getTheAssetsTotal(erpCredits);
           for (int i = 0; i < theAssetsTotals.size(); i++) {
               theAssetsTotal = theAssetsTotals.get(i);
               row = (XSSFRow) sheet.getRow((int)i+6);
               cell = row.getCell(2);
               cell.setCellValue(theAssetsTotal.getBuildProject());
               cell=row.getCell(3);
               cell.setCellValue(theAssetsTotal.getIntallProject());
               cell=row.getCell(4);
               cell.setCellValue(theAssetsTotal.getEquipmentValue());
               cell=row.getCell(5);
               cell.setCellValue(theAssetsTotal.getCostSharing());
               cell=row.getCell(6);
               cell.setCellValue(theAssetsTotal.getDeliveryCostValue());
           }
       }
    }
    public static void getSheet8(Sheet sheet,List<ErpCredit> erpCredits,List<MaintainData> maintainDataList){
        if (null!=sheet){
            XSSFRow row = (XSSFRow) sheet.getRow(0);
            XSSFCell cell = row.getCell(0);
            MCompletionProject mCompletionProject = ExportUtil1.getMCompletionProject(erpCredits,maintainDataList);
            row = (XSSFRow) sheet.getRow(6);
            cell=row.getCell(5);
            cell.setCellValue(mCompletionProject.getFixedAssets());
            row = (XSSFRow) sheet.getRow(11);
            cell=row.getCell(5);
            cell.setCellValue(mCompletionProject.getVatDeduction());

            row = (XSSFRow) sheet.getRow(15);
            cell=row.getCell(2);
            cell.setCellValue(mCompletionProject.getAppropriatedFunds());
        }
    }
    public static CellStyle getCellStyle(Workbook workbook){
        XSSFFont font = (XSSFFont) workbook.createFont();
        font.setFontHeightInPoints((short) 12);//设置字体大小
        font.setBoldweight(HSSFFont.BOLDWEIGHT_BOLD);//粗体显示
        CellStyle style=workbook.createCellStyle();
        style.setFont(font);
        return style;
    }
}
